/** --------------------------------------------------------------------
/** utils.c
/** Functions common to the pquota programs.
/**
**/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

/** --------------------------------------------------------------------
/** readnet(fd, ptr, nbytes)
/** Function to read n-bytes from a stream socket file descriptor.
/** Data is read until a newline is seen or an error occures.
/** The string, prt, is returned null-terminated.
/**
**/
int readnet(fd, ptr, nbytes)
register int fd;
register char *ptr;
register int nbytes;
{
   int n, rc;
   char c;

   *ptr = 0;
   for (n=1; n<nbytes; n++) {
      if ((rc=read(fd, &c, 1)) == 1) {
	 *ptr++ = c;
	 if (c == '\n') 
	    break;
      }
      else if (rc == 0) {
	 if (n == 1) 
	    return(0);   /* EOF, no data read */
	 else 
	    break;       /* EOF, some data read. */
      }
      else 
	 return(-1);     /* Error. */
   }
   *ptr = NULL;
   return(n);
}

/** --------------------------------------------------------------------
/** writenet(fd, ptr, nbytes)
/** Function to write n-bytes to a stream socket file descriptor.
/**
**/
int writenet(fd, ptr, nbytes)
register int fd;
register char *ptr;
register int nbytes;
{
   int nleft, nwritten;
   nleft = nbytes;
   while (nleft > 0) {
      nwritten = write(fd, ptr, nleft);
      if (nwritten <= 0) {
	 return(nwritten);         /* Error. Return < 0. */
      }
      nleft -= nwritten;
      ptr   += nwritten;
   }
   return(nbytes - nleft);
}

/* End of file */
